<?php

declare(strict_types=1);

namespace App\Repository;

final class TblRespuestaRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblRespuestaId): object
    {
        $query = 'SELECT * FROM `TblRespuesta` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblRespuestaId);
        $statement->execute();
        $TblRespuesta = $statement->fetchObject();
        if (! $TblRespuesta) {
            throw new \Exception('TblRespuesta not found.', 404);
        }

        return $TblRespuesta;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblRespuesta` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblRespuesta): object
    {
        $query = 'INSERT INTO `TblRespuesta` (`Respuesta`, `RespuestaCorrecta`, `IdPregunta`, `Codigo`, `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:Respuesta, :RespuestaCorrecta, :IdPregunta, :Codigo, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblRespuesta->id);
//         $statement->bindParam('fecha', $TblRespuesta->fecha);
        $statement->bindParam('Respuesta', $TblRespuesta->Respuesta);
        $statement->bindParam('RespuestaCorrecta', $TblRespuesta->RespuestaCorrecta);
        $statement->bindParam('IdPregunta', $TblRespuesta->IdPregunta);
        $statement->bindParam('Codigo', $TblRespuesta->Codigo);
        $statement->bindParam('field1', $TblRespuesta->field1);
        $statement->bindParam('field2', $TblRespuesta->field2);
        $statement->bindParam('field3', $TblRespuesta->field3);
        $statement->bindParam('field4', $TblRespuesta->field4);
        $statement->bindParam('field5', $TblRespuesta->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblRespuesta, object $data): object
    {
        if (isset($data->fecha)) {
            $TblRespuesta->fecha = $data->fecha;
        }
        if (isset($data->Respuesta)) {
            $TblRespuesta->Respuesta = $data->Respuesta;
        }
        if (isset($data->RespuestaCorrecta)) {
            $TblRespuesta->RespuestaCorrecta = $data->RespuestaCorrecta;
        }
        if (isset($data->IdPregunta)) {
            $TblRespuesta->IdPregunta = $data->IdPregunta;
        }
        if (isset($data->Codigo)) {
            $TblRespuesta->Codigo = $data->Codigo;
        }
        if (isset($data->field1)) {
            $TblRespuesta->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblRespuesta->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblRespuesta->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblRespuesta->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblRespuesta->field5 = $data->field5;
        }

        $query = 'UPDATE `TblRespuesta` SET `fecha` = :fecha, `Respuesta` = :Respuesta, `RespuestaCorrecta` = :RespuestaCorrecta, `IdPregunta` = :IdPregunta, `Codigo` = :Codigo, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblRespuesta->id);
        $statement->bindParam('fecha', $TblRespuesta->fecha);
        $statement->bindParam('Respuesta', $TblRespuesta->Respuesta);
        $statement->bindParam('RespuestaCorrecta', $TblRespuesta->RespuestaCorrecta);
        $statement->bindParam('IdPregunta', $TblRespuesta->IdPregunta);
        $statement->bindParam('Codigo', $TblRespuesta->Codigo);
        $statement->bindParam('field1', $TblRespuesta->field1);
        $statement->bindParam('field2', $TblRespuesta->field2);
        $statement->bindParam('field3', $TblRespuesta->field3);
        $statement->bindParam('field4', $TblRespuesta->field4);
        $statement->bindParam('field5', $TblRespuesta->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblRespuesta->id);
    }

    public function delete(int $TblRespuestaId): void
    {
        $query = 'DELETE FROM `TblRespuesta` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblRespuestaId);
        $statement->execute();
    }
}
